VERSION 5.00
Begin VB.Form frmCompareFiles 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Datei - Vergleich zum Vorgnger"
   ClientHeight    =   3000
   ClientLeft      =   36
   ClientTop       =   324
   ClientWidth     =   4548
   Icon            =   "frmCompareFiles.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3000
   ScaleWidth      =   4548
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Schliessen"
      Height          =   372
      Left            =   3120
      TabIndex        =   5
      Top             =   2520
      Width           =   1332
   End
   Begin VB.TextBox txtPathRepository 
      BackColor       =   &H8000000A&
      BorderStyle     =   0  'Kein
      Height          =   288
      Left            =   1680
      Locked          =   -1  'True
      TabIndex        =   3
      Text            =   "---"
      Top             =   120
      Width           =   2772
   End
   Begin VB.TextBox txtPathProject 
      BackColor       =   &H8000000A&
      BorderStyle     =   0  'Kein
      Height          =   288
      Left            =   1680
      Locked          =   -1  'True
      TabIndex        =   1
      Text            =   "---"
      Top             =   480
      Width           =   2772
   End
   Begin VB.Label lblCompareInfo 
      Caption         =   "Keine Info vorhanden."
      Height          =   1452
      Left            =   120
      TabIndex        =   4
      Top             =   960
      Width           =   4332
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   4440
      Y1              =   840
      Y2              =   840
   End
   Begin VB.Label Label3 
      Caption         =   "Repository-Pfad:"
      Height          =   252
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   1452
   End
   Begin VB.Label Label2 
      Caption         =   "Projekt-Pfad:"
      Height          =   252
      Left            =   120
      TabIndex        =   0
      Top             =   480
      Width           =   1452
   End
End
Attribute VB_Name = "frmCompareFiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    Dim fileRelativePath As String
    Dim filePathProject As String
    Dim filePathRepository As String

    fileRelativePath = frmMain.trvFiles.SelectedItem.FullPath

    filePathProject = modRevisioner.getPathFrom
    filePathProject = filePathProject & "\" & fileRelativePath

    filePathRepository = getLatestBackupFolder & "\" & fileRelativePath
    
    txtPathRepository.text = filePathRepository
    txtPathProject.text = filePathProject
    
    lblCompareInfo.Caption = getCompareInfo(filePathRepository, filePathProject)
End Sub

Private Function getCompareInfo(ByVal pathRepository As String, ByVal pathProject As String) As String
    Dim info As String
    Dim areSame As Boolean
    Dim fileSystem As Object
    
    info = ""

    Set fileSystem = CreateObject("Scripting.FileSystemObject")
    If fileSystem.fileExists(pathRepository) And _
            fileSystem.fileExists(pathProject) Then
            
        areSame = compareFiles(pathRepository, pathProject)
        
        If areSame Then
            info = info & "Die beiden Dateien sind gleich. "
        
        Else
            info = info & "Die beiden Dateien unterscheiden sich " & _
                    "im Inhalt und sind nicht gleich. "
            info = info & getCompareSizeInfo(pathRepository, pathProject)
            info = info & getCompareDateInfo(pathRepository, pathProject)
        End If
    
    Else
        If Not fileSystem.fileExists(pathRepository) Then
            info = "Diese Datei existiert noch nicht im Repository. Die " & _
                    "Datei im Projekt-Ordner wurde also vermutlich neu angelegt, " & _
                    "oder von einem anderen Platz hierhin verschoben."
        End If
    End If

    getCompareInfo = info
End Function

Private Function getCompareSizeInfo(ByVal pathRepository As String, ByVal pathProject As String) As String
    Dim info As String
    Dim lenRepository As Long
    Dim lenProject As Long
    Dim lenDifference As Long
    Dim byteRepository As String
    Dim byteProject As String
    Dim byteDifference As String
            
    info = ""
    
    lenRepository = FileLen(pathRepository)
    lenProject = FileLen(pathProject)
    lenDifference = Abs(lenRepository - lenProject)
    
    byteRepository = formatByte(lenRepository)
    byteProject = formatByte(lenProject)
    byteDifference = formatByte(lenDifference)
    
    If lenProject > lenRepository Then
        info = info & "Die Datei im Projekt-Ordner ist mit " & _
                byteProject & " um " & byteDifference & " " & _
                "grer als die Datei im Repository. "
    ElseIf lenProject < lenRepository Then
        info = info & "Die Datei im Projekt-Ordner ist mit " & _
                byteProject & " um " & byteDifference & " " & _
                "kleiner als die Datei im Repository. "
    Else ' If lenProject = lenRepository Then
        info = info & "Die Datei im Projekt-Ordner und im Repository " & _
                "haben beide eine Gre von " & byteProject & ". "
    End If
    
    getCompareSizeInfo = info
End Function

Private Function getCompareDateInfo(ByVal pathRepository As String, ByVal pathProject As String) As String
    Const bySecond = "s"
    Dim info As String
    Dim projectDate As Date
    Dim repositoryDate As Date
    Dim dateDifference As Long
    
    info = ""
    
    projectDate = FileDateTime(pathProject)
    repositoryDate = FileDateTime(pathRepository)
    dateDifference = Abs(DateDiff(bySecond, projectDate, repositoryDate))
    
    If projectDate > repositoryDate Then
        info = info & "Die Datei im Projekt-Ordner ist um " & _
                formatTime(dateDifference) & " aktueller als die im Repository. "
    ElseIf projectDate < repositoryDate Then
        info = info & "Die Datei im Projekt-Ordner ist um " & _
                formatTime(dateDifference) & " lter als die im Repository. "
    
    End If
    
    getCompareDateInfo = info
End Function

Function compareFiles(sFile1path As String, sFile2path As String) As Boolean
    Dim fileHandle1 As Long
    Dim fileHandle2 As Long
    
    compareFiles = True

    On Error GoTo errHandler
    
    If FileLen(sFile1path) <> FileLen(sFile2path) Then
        compareFiles = False
    Else
        fileHandle1 = FreeFile
        Open sFile1path For Binary Access Read As #fileHandle1
        fileHandle2 = FreeFile
        Open sFile2path For Binary Access Read As #fileHandle2
        Do While Not EOF(1)
            If InputB(1, #fileHandle1) <> InputB(1, #fileHandle2) Then
                compareFiles = False
                Exit Function
            End If
        Loop
        Close #fileHandle1
        Close #fileHandle2
    End If
    
    Exit Function

errHandler:
        MsgBox "Fehler beim Dateivergleich " & _
                "von " & sFile1path & " und " & sFile2path & "."
        compareFiles = False
End Function
