Attribute VB_Name = "modMisc"
Option Explicit

Public Const SW_SHOW = 1

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Function removeCharacterFromRight(ByVal text As String, ByVal toRemove As String) As String
    If Right$(text, Len(toRemove)) = toRemove Then
        text = Left$(text, Len(text) - Len(toRemove))
    End If

    removeCharacterFromRight = text
End Function

Public Function getFolderName(ByVal path As String) As String
    getFolderName = getFolderOrFileName(path)
End Function

Public Function getFileName(ByVal path As String) As String
    getFileName = getFolderOrFileName(path)
End Function

Public Function getFolderOrFileName(ByVal path As String) As String
    Dim lastSlash As Long
    Dim lastBackSlash As Long
    Dim folderName As String
    
    folderName = path
    
    lastSlash = InStrRev(path, "/")
    lastBackSlash = InStrRev(path, "\")
    
    If lastSlash >= 1 Then
        folderName = Mid$(path, lastSlash + 1)
    ElseIf lastBackSlash >= 1 Then
        folderName = Mid$(path, lastBackSlash + 1)
    End If
    
    getFolderOrFileName = folderName
End Function

Public Function getProperCase(ByVal text As String) As String
    Dim properCase As String
    
    properCase = ""
    If text <> properCase Then
        properCase = UCase$(Left$(text, 1)) & _
                Right$(text, Len(text) - 1)
    End If
    
    getProperCase = properCase
End Function

Public Function prefixNumber(ByVal text As String, ByVal count As String, Optional ByVal prefix As String = "0") As String
    prefixNumber = String$(count - Len(text), prefix) & text
End Function

Public Function getAsName(ByVal text As String) As String
    Const replaceCharacter = "_"
    Dim i As Long
    Dim newText As String
    Dim letter As String
    Dim newLetter As String
    
    newText = ""
    text = LCase$(text)
    text = Trim$(text)
    text = replaceLowerUmlaute(text)
    
    For i = 1 To Len(text)
        letter = Mid$(text, i, 1)
        If (letter >= "a" And letter <= "z") Or _
                (letter >= "0" And letter <= "9") Then
            newLetter = letter
        Else
            newLetter = replaceCharacter
        End If
        newText = newText & newLetter
    Next
    
    getAsName = newText
End Function

Public Function getFromName(ByVal text As String)
    Const replaceCharacter = "_"
    
    getFromName = Replace$(text, replaceCharacter, " ")
End Function

Public Function replaceLowerUmlaute(ByVal text As String) As String
    text = Replace$(text, "", "ae")
    text = Replace$(text, "", "oe")
    text = Replace$(text, "", "ue")
    text = Replace$(text, "", "ss")
    
    replaceLowerUmlaute = text
End Function

Public Function formatByte(ByVal fileLengthInByte As Long) As String
    Dim text As String
    Const kilo = 1024
    
    If fileLengthInByte \ kilo = 0 Then
        text = fileLengthInByte & " Bytes"
    Else
        text = Format$((fileLengthInByte / kilo), "0") & " KB"
    End If
    
    formatByte = text
End Function

Public Sub startStandardProgram(ByRef frm As Form, ByVal document_name As String)
    ' Invoke the application associated with a document type.
    ShellExecute frm.hwnd, "open", document_name, "", "", SW_SHOW
End Sub

Public Sub clearList(ByRef lst As ListView)
    Const firstItem = 1
    
    Do While lst.ListItems.count >= firstItem
        lst.ListItems.Remove firstItem
    Loop
End Sub

Public Function formatTime(ByVal seconds As Long) As String
    Const secondsInMinute = 60
    Const minutesInHour = 60
    Const hoursInDay = 24
    Const daysInYear = 356
    Dim text As String
    Dim minutes As Long
    Dim hours As Long
    Dim days As Long
    Dim months As Long
    Dim years As Long
    Dim debugString As String
    
    minutes = seconds / secondsInMinute
    hours = minutes / minutesInHour
    days = hours / hoursInDay
    years = days / daysInYear
    
    debugString = "seconds = " & seconds & vbNewLine & _
            "minutes = " & minutes & vbNewLine & _
            "hours = " & hours & vbNewLine & _
            "days = " & days & vbNewLine & _
            "years = " & years
    'MsgBox debugString

    If years >= 1 Then
        text = years & " Jahre"
    ElseIf days >= 1 Then
        text = days & " Tage"
    ElseIf hours >= 1 Then
        text = hours & " Stunden"
    ElseIf minutes >= 1 Then
        text = minutes & " Minuten"
    Else
        text = seconds & " Sekunden"
    End If
    
    formatTime = text
End Function

Public Function dateChanged(ByRef fileSystem As Object, ByVal path1 As String, ByVal path2 As String) As Boolean
    Const cSeconds = "s"
    Const differenceSecondsStillOk = 3
    Dim didChange As Boolean
    Dim differenceSeconds As Long
    Dim fileDate1 As Date
    Dim fileDate2 As Date
    
    didChange = False
    
    If fileSystem.fileExists(path1) And fileSystem.fileExists(path2) Then
        fileDate1 = FileDateTime(path1)
        fileDate2 = FileDateTime(path2)
        differenceSeconds = DateDiff(cSeconds, fileDate1, fileDate2)
        differenceSeconds = Abs(differenceSeconds)
        
        didChange = differenceSeconds > differenceSecondsStillOk
    Else
        
        didChange = True
    End If
    
    dateChanged = didChange
End Function

