Attribute VB_Name = "modVersions"
Option Explicit

Type tpeRevision
    version As String
    user As String
    comment As String
End Type

Public Enum enmItem
    version = 0
    user
    comment
    Date
    Size
End Enum

Public Sub handleUpdateVersions(ByRef lstVersions As ListView)
    Static didUpdateVersions As Boolean
    Dim pointerBefore As Long
    
    pointerBefore = frmMain.MousePointer
    frmMain.MousePointer = vbHourglass
    If didUpdateVersions Then
        clearList lstVersions
    End If
    
    doUpdateVersions lstVersions
    didUpdateVersions = True
    
    frmMain.MousePointer = pointerBefore
End Sub

Public Sub doUpdateVersions(ByRef lstVersions As ListView)
    Static nextVersion As Long
    Dim revision As tpeRevision
    Dim fileSystem As Object
    Dim subFolder As Object
    Dim oFolder As Object
    Dim folderName As String
    Dim folderPath As String
    Dim splitted() As String
    Dim i As Long
    Dim newItem As ListItem
    Dim iconName As String

    If nextVersion = 0 Then
        nextVersion = 1
    End If

    Set fileSystem = CreateObject("Scripting.FileSystemObject")
    folderPath = frmMain.txtPathRevisionRoot.text & "\" & _
            Mid$(frmMain.txtPathSource.text, _
            Len(frmMain.txtPathSourceRoot.text) + 2)
    
    If fileSystem.folderExists(folderPath) Then
        Set oFolder = fileSystem.getFolder(folderPath)
        
        If Not frmMain.gDidRevisionize Then
            nextVersion = getNextVersion(oFolder)
        End If
                
        For Each subFolder In oFolder.subFolders
            folderName = subFolder.Name
                    
            splitted = Split(folderName, "_")
            If UBound(splitted) >= enmItem.user Then
                revision.version = splitted(enmItem.version)
                revision.user = splitted(enmItem.user)
                
                revision.comment = ""
                If UBound(splitted) >= enmItem.comment Then
                    For i = enmItem.comment To UBound(splitted)
                        revision.comment = revision.comment & _
                                " " & splitted(i)
                    Next
                    revision.comment = Trim$(revision.comment)
                    revision.comment = getProperCase(revision.comment)
                End If
                
                If CLng(revision.version) = nextVersion Then
                    iconName = "versionNew"
                Else
                    iconName = "version"
                End If
                
                Set newItem = lstVersions.ListItems.Add(, , _
                        revision.version, , iconName)
                
                With newItem
                    .SubItems(enmItem.user) = getProperCase(revision.user)
                    .SubItems(enmItem.comment) = revision.comment
                    .SubItems(enmItem.Date) = subFolder.datecreated
                    .SubItems(enmItem.Size) = "Unknown" ' formatByte(subFolder.Size)
                    .Tag = subFolder.path
                End With
                
            End If
        Next
    
    End If
    
    frmMain.txtNextVersion.text = nextVersion
End Sub

Private Function getNextVersion(ByRef oFolder As Object) As Long
    getNextVersion = getHighestVersion(oFolder) + 1
End Function

Public Function getHighestVersion(ByRef oFolder As Object) As Long
    Dim splitted() As String
    Dim folderName As String
    Dim revision As tpeRevision
    Dim subFolder As Object
    Dim highestVersion As Long
    
    highestVersion = 1

    For Each subFolder In oFolder.subFolders
        folderName = subFolder.Name
                
        splitted = Split(folderName, "_")
        If UBound(splitted) >= enmItem.user Then
            revision.version = splitted(enmItem.version)
            If CLng(revision.version) > highestVersion Then
                highestVersion = CLng(revision.version)
            End If
        End If
    Next
    
    getHighestVersion = highestVersion
End Function
